"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var core_2 = require('@ngx-translate/core');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var actions_service_1 = require('../services/actions.service');
var emi_service_1 = require('../../emi.service');
var messagemodal_component_1 = require('ng2-catalogic/modal/messagemodal.component');
var ActionsComponent = (function () {
    function ActionsComponent(coreService, actionsService, emiService, translate) {
        var _this = this;
        this.coreService = coreService;
        this.actionsService = actionsService;
        this.emiService = emiService;
        this.translate = translate;
        this.stepversionfontcolor = 'grey';
        this.isServerAdmin = false;
        this.productRunning = false;
        this.somethingIsRunning = false;
        this.actionsCmdStartappInitialize = true;
        this.actionsCmdStartappRunning = false;
        this.actionsCmdStartappSuccess = false;
        this.actionsCmdStopappInitialize = true;
        this.actionsCmdStopappRunning = false;
        this.actionsCmdStopappSuccess = false;
        this.actionsCmdRestartappInitialize = true;
        this.actionsCmdRestartappRunning = false;
        this.actionsCmdRestartappSuccess = false;
        this.actionsCmdAppstatusRunning = false;
        this.actionsCmdAppstatusSuccess = false;
        this.actionsCmdRestartInitialize = true;
        this.actionsCmdRestartRunning = false;
        this.actionsCmdRestartSuccess = false;
        this.actionsCmdResetPasswordInitialize = true;
        this.actionsCmdResetPasswordRunning = false;
        this.actionsCmdResetPasswordSuccess = false;
        this.manageAppSubscriptionErrors = false;
        this.sessionTimeoutException = false;
        this.showChangeTimezone = false;
        this.showCurrentTimezone = false;
        this.showTimezoneUpdateSuccess = false;
        this.updatingTimezone = false;
        this.productName = this.getProductName();
        translate
            .get([
            'ACTIONS.TIMEZONE_DROPDOWN_DEFAULT_LABEL',
            'ACTIONS.RESET_SUCCESS',
            'ACTIONS.RESET_PASSWORD',
            'ACTIONS.RESET_PASSWORD_FAILURE'
        ])
            .subscribe(function (res) {
            _this.dropdownlabel = res['ACTIONS.TIMEZONE_DROPDOWN_DEFAULT_LABEL'];
            _this.resetSuccesMsg = res['ACTIONS.RESET_SUCCESS'];
            _this.resetHeader = res['ACTIONS.RESET_PASSWORD'];
            _this.resetHeaderFail = res['ACTIONS.RESET_PASSWORD_FAILURE'];
        });
    }
    ActionsComponent.prototype.ngOnInit = function () {
        if (this.emiService.getSessionTimeOutStatus()) {
            this.sessionTimeoutException = true;
            this.manageAppSubscriptionErrors = true;
        }
        else {
            this.manageApp('appstatus');
            this.getTimezones();
            this.checkUser();
        }
    };
    ActionsComponent.prototype.checkUser = function () {
        var _this = this;
        this.actionsService.checkSession().subscribe(function (res) {
            _this.isServerAdmin = res.validSession ? res.serveradmin : false;
        }, function (error) {
            _this.errorMessage = error;
            console.error('ActionsComponent ==> checkUser() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
        });
    };
    ActionsComponent.prototype.getProductName = function () {
        return this.emiService.getProductName();
    };
    ActionsComponent.prototype.getCompanyName = function () {
        return this.emiService.getCompanyName();
    };
    ActionsComponent.prototype.getTimezones = function () {
        var _this = this;
        this.actionsService.getTimezones().subscribe(function (timezones) {
            _this.dropdownvalues = timezones;
            _this.showChangeTimezone = true;
        }, function (error) {
            _this.errorMessage = error;
            console.error('ActionsComponent ==> getTimezones() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
        });
    };
    ActionsComponent.prototype.onSelect = function (value) {
        var _this = this;
        console.log('ActionsComponent ==> onSelect() ==> ' + value);
        this.dropdownlabel = value;
        this.updatingTimezone = true;
        this.actionsService.changeTimezone(value).subscribe(function (commandoutput) {
            _this.updatingTimezone = false;
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === '0') {
                _this.showTimezoneUpdateSuccess = true;
            }
        }, function (error) {
            _this.updatingTimezone = false;
            _this.errorMessage = error;
            console.error('ActionsComponent ==> onSelect() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
        });
    };
    ActionsComponent.prototype.getCurrentTimezone = function () {
        var _this = this;
        this.actionsService.getCurrentTimezone().subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === '0') {
                _this.currentTimezone = commandoutput.commandOutput;
                _this.showCurrentTimezone = true;
            }
        }, function (error) {
            _this.errorMessage = error;
            console.error('ActionsComponent ==> getCurrentTimezone() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
        });
    };
    ActionsComponent.prototype.reinitialize = function (mode) {
        console.log('ActionsComponent ==> reinitialize() ==> ' + mode);
        this.actionsReinitializeType = mode;
        if (this.actionsReinitializeType === 'startapp') {
            this.actionsCmdStartappInitialize = true;
            this.actionsCmdStartappSuccess = false;
            this.productRunning = true;
        }
        else if (this.actionsReinitializeType === 'stopapp') {
            this.actionsCmdStopappInitialize = true;
            this.actionsCmdStopappSuccess = false;
            this.productRunning = false;
        }
        else if (this.actionsReinitializeType === 'restartapp') {
            this.actionsCmdRestartappInitialize = true;
            this.actionsCmdRestartappSuccess = false;
            this.productRunning = true;
        }
        else if (this.actionsReinitializeType === 'restart') {
            this.actionsCmdRestartInitialize = true;
        }
        else if (this.actionsReinitializeType === 'reset') {
            this.actionsCmdResetPasswordInitialize = true;
            this.actionsCmdResetPasswordRunning = false;
            this.actionsCmdResetPasswordSuccess = false;
        }
    };
    ActionsComponent.prototype.openModal = function () {
        $('.tiny.modal').modal('show');
    };
    ActionsComponent.prototype.closeModal = function () {
        $('.tiny.modal').modal('hide');
    };
    ActionsComponent.prototype.resetPassword = function () {
        var _this = this;
        this.actionsCmdResetPasswordInitialize = false;
        this.actionsCmdResetPasswordRunning = true;
        this.actionsService.resetSuperuserPassword().subscribe(function (res) {
            _this.actionsCmdResetPasswordRunning = false;
            _this.errorCode = res.commandoutput.errorCode;
            if (_this.errorCode === '0' && res['success']) {
                console.log('ActionsComponent => resetPassword() ==>  ' +
                    ' password reset successfully');
                _this.closeModal();
                _this.resetPasswordSuccess();
            }
            else {
                console.log('ActionsComponent => resetPassword() ==>  ' +
                    ' password reset failed');
                if (res.commandoutput) {
                    _this.errorCode = res.commandoutput.errorCode;
                    _this.errorMessage = res.commandoutput.commandErrorOutput;
                }
                console.error('ActionsComponent ==> manageApp() ==> ' + _this.errorMessage);
                _this.closeModal();
                _this.resetPasswordFailure();
            }
        }, function (error) {
            _this.actionsCmdResetPasswordRunning = false;
            console.log('ActionsComponent => resetPassword() ==>  ' + ' password reset failed');
            _this.errorMessage = error;
            console.error('ActionsComponent ==> manageApp() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.closeModal();
        });
    };
    ActionsComponent.prototype.resetPasswordSuccess = function () {
        this.actionsCmdResetPasswordSuccess = true;
    };
    ActionsComponent.prototype.resetPasswordFailure = function () {
        this.reinitialize('reset');
        this.msgModal.popMessageModal('red warning circle', this.resetHeaderFail, this.errorMessage, 4000);
    };
    ActionsComponent.prototype.manageApp = function (mode) {
        var _this = this;
        console.log('ActionsComponent ==> manageApp() ==> ' + mode);
        this.actionsType = mode;
        this.somethingIsRunning = true;
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getNavigationStatusKey(), false);
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getAdminconsoleNavigationStatusKey(), false);
        if (this.actionsType === 'startapp') {
            this.actionsCmdStartappInitialize = false;
            this.actionsCmdStartappRunning = true;
        }
        else if (this.actionsType === 'stopapp') {
            this.actionsCmdStopappInitialize = false;
            this.actionsCmdStopappRunning = true;
        }
        else if (this.actionsType === 'restartapp') {
            this.actionsCmdRestartappInitialize = false;
            this.actionsCmdRestartappRunning = true;
        }
        else if (this.actionsType === 'appstatus') {
            this.actionsCmdAppstatusRunning = true;
        }
        else if (this.actionsType === 'restart') {
            this.actionsCmdRestartInitialize = false;
            this.actionsCmdRestartRunning = true;
        }
        this.actionsService.manageAppService(this.actionsType).subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === '0') {
                if (_this.actionsType === 'startapp') {
                    _this.actionsCmdStartappSuccess = true;
                    _this.actionsCmdStartappRunning = false;
                }
                else if (_this.actionsType === 'stopapp') {
                    _this.actionsCmdStopappSuccess = true;
                    _this.actionsCmdStopappRunning = false;
                }
                else if (_this.actionsType === 'restartapp') {
                    _this.actionsCmdRestartappSuccess = true;
                    _this.actionsCmdRestartappRunning = false;
                }
                else if (_this.actionsType === 'appstatus') {
                    _this.productRunning = true;
                    _this.actionsCmdAppstatusSuccess = true;
                    _this.actionsCmdAppstatusRunning = false;
                }
                else if (_this.actionsType === 'restart') {
                    _this.actionsCmdRestartSuccess = true;
                    _this.actionsCmdRestartRunning = false;
                }
            }
            _this.somethingIsRunning = false;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        }, function (error) {
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            _this.errorMessage = error;
            console.error('ActionsComponent ==> manageApp() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
        });
    };
    /**
     * DELETE COOKIES
     * (Created cookies needs to be deleted here)
     */
    ActionsComponent.prototype.deleteCreatedCookies = function () {
        console.log('ActionComponent => deleteCreatedCookies ==>');
        this.coreService.deleteCookie('adminconsole_portal_url');
        this.coreService.deleteCookie('adminconsole_ms_url');
        this.coreService.deleteCookie('adminconsole_emims_url');
        this.coreService.deleteCookie('adminconsole_company_name');
        this.coreService.deleteCookie('adminconsole_product_name');
        this.coreService.deleteCookie('licenseinfo');
    };
    __decorate([
        core_1.ViewChild('dropdown_tag'), 
        __metadata('design:type', Object)
    ], ActionsComponent.prototype, "dropDown", void 0);
    __decorate([
        core_1.ViewChild('message_tag'), 
        __metadata('design:type', (typeof (_a = typeof messagemodal_component_1.MessageModal !== 'undefined' && messagemodal_component_1.MessageModal) === 'function' && _a) || Object)
    ], ActionsComponent.prototype, "msgModal", void 0);
    ActionsComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'actions',
            templateUrl: '../views/actions.component.html',
        }), 
        __metadata('design:paramtypes', [(typeof (_b = typeof core_service_1.CoreService !== 'undefined' && core_service_1.CoreService) === 'function' && _b) || Object, actions_service_1.ActionsService, emi_service_1.EMIService, core_2.TranslateService])
    ], ActionsComponent);
    return ActionsComponent;
    var _a, _b;
}());
exports.ActionsComponent = ActionsComponent;
