"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var Observable_1 = require('rxjs/Observable');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
require('rxjs/add/operator/map');
require('rxjs/add/operator/catch');
var emi_service_1 = require('../../emi.service');
var ActionsService = (function () {
    function ActionsService(http, emiService, coreService) {
        this.http = http;
        this.emiService = emiService;
        this.coreService = coreService;
        this.manageAppUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/manageapp';
        this.currentTimezoneUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/getcurrenttimezone';
        this.getTimezonesUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/gettimezones';
        this.changeTimezoneUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/changetimezone';
        this.resetPassword = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/resetpassword';
        this.sessionUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/validatesession';
    }
    ActionsService.prototype.manageAppService = function (mode) {
        console.log('ActionsService ==> manageAppService() ==> ' + mode);
        var formData = new FormData();
        if (mode === "startapp") {
            formData.append('appaction', 'startapp');
        }
        else if (mode === "stopapp") {
            formData.append('appaction', 'stopapp');
        }
        else if (mode === "restartapp") {
            formData.append('appaction', 'restartapp');
        }
        else if (mode === "appstatus") {
            formData.append('appaction', 'appstatus');
        }
        else if (mode === "restart") {
            formData.append('appaction', 'restart');
        }
        else {
            console.log('Unsupported mode');
            formData.append('appaction', 'appstatus');
        }
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.manageAppUrl, formData, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ActionsService.prototype.getCurrentTimezone = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.currentTimezoneUrl, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ActionsService.prototype.getTimezones = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.getTimezonesUrl, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ActionsService.prototype.changeTimezone = function (timezone) {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        var formData = new FormData();
        formData.append('timezone', timezone);
        return this.http.post(this.changeTimezoneUrl, formData, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    ActionsService.prototype.resetSuperuserPassword = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.resetPassword, null, options)
            .map(function (res) { return res.json(); })
            .catch(this.handleError);
    };
    ActionsService.prototype.checkSession = function () {
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.get(this.sessionUrl, options)
            .map(this.extractData)
            .catch(this.handleError);
    };
    ActionsService.prototype.extractData = function (res) {
        var body = res.json();
        return body || {};
    };
    ActionsService.prototype.extractDataCommandOutput = function (res) {
        var body = res.json();
        return body.commandoutput || {};
    };
    ActionsService.prototype.handleError = function (error) {
        // In a real world app, we might use a remote logging infrastructure
        var errMsg;
        if (error instanceof http_1.Response) {
            var body = error.json() || '';
            if (body.message !== undefined && body.message !== null) {
                if (body.message === "SessionId Timeout") {
                    errMsg = "SessionIdTimeout";
                }
                else {
                    var err = body.error || JSON.stringify(body);
                    errMsg = error.status + " - " + (error.statusText || '') + " " + err;
                }
            }
            else {
                var err = body.error || JSON.stringify(body);
                errMsg = error.status + " - " + (error.statusText || '') + " " + err;
            }
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        console.error('ActionsService ==> handleError() ==> ' + errMsg);
        return Observable_1.Observable.throw(errMsg);
    };
    ActionsService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, emi_service_1.EMIService, (typeof (_a = typeof core_service_1.CoreService !== 'undefined' && core_service_1.CoreService) === 'function' && _a) || Object])
    ], ActionsService);
    return ActionsService;
    var _a;
}());
exports.ActionsService = ActionsService;
