"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var certificate_service_1 = require('../services/certificate.service');
var emi_service_1 = require('../../emi.service');
var CertificateComponent = (function () {
    function CertificateComponent(certificateService, emiService) {
        this.certificateService = certificateService;
        this.emiService = emiService;
        this.uploadHttpsButtonState = true;
        this.uploadLdapButtonState = true;
        this.httpsCmdSuccess = false;
        this.httpsShowCmdResponseWindow = false;
        this.ldapCmdSuccess = false;
        this.ldapShowCmdResponseWindow = false;
        this.doesHttpsCertificateFileExist = false;
        this.showHttps = true;
        this.showLdap = false;
        this.cmodel = { certtype: 'https' };
        this.sessionTimeoutException = false;
        this.certificateSubscriptionErrors = false;
        this.showCertificateDeploymentRunning = false;
        this.productName = this.getProductName();
    }
    CertificateComponent.prototype.ngOnInit = function () {
        if (this.emiService.getSessionTimeOutStatus()) {
            this.sessionTimeoutException = true;
            this.certificateSubscriptionErrors = true;
        }
    };
    CertificateComponent.prototype.certTypeEvent = function (ctype) {
        this.certType = ctype;
        if (this.certType == 1) {
            this.showHttps = true;
            this.showLdap = false;
        }
        else if (this.certType == 2) {
            this.showLdap = true;
            this.showHttps = false;
        }
    };
    CertificateComponent.prototype.getProductName = function () {
        return this.emiService.getProductName();
    };
    CertificateComponent.prototype.getCompanyName = function () {
        return this.emiService.getCompanyName();
    };
    CertificateComponent.prototype.fileChangeEventHttps = function (event) {
        this.filesToUploadHttps = event.target.files;
        if (this.filesToUploadHttps.length > 0) {
            this.uploadHttpsButtonState = false;
        }
    };
    CertificateComponent.prototype.fileChangeEventLdap = function (event) {
        this.filesToUploadLdap = event.target.files;
        if (this.filesToUploadLdap.length > 0) {
            this.uploadLdapButtonState = false;
        }
    };
    CertificateComponent.prototype.checkHttpsCertificate = function () {
        var _this = this;
        this.certificateService.checkHttpsCertificate()
            .subscribe(function (filedetails) {
            _this.doesHttpsCertificateFileExist = filedetails.doesFileExist;
            _this.httpsCertificatefileTime = filedetails.fileTime;
        }, function (error) {
            _this.errorMessage = error;
            console.error('CertificateComponent ==> checkHttpsCertificate() ==> ' + _this.errorMessage);
        });
    };
    CertificateComponent.prototype.updateHttpsCertificate = function () {
        this.doesHttpsCertificateFileExist = false;
    };
    CertificateComponent.prototype.tryNewHttpsCertificate = function () {
        this.httpsShowCmdResponseWindow = false;
    };
    CertificateComponent.prototype.manageHttpsCertificate = function () {
        var _this = this;
        this.httpsShowCmdResponseWindow = true;
        this.showCertificateDeploymentRunning = true;
        var file = this.filesToUploadHttps[0];
        this.certificateService.uploadHttpsCertificate(file)
            .subscribe(function (commandoutput) {
            _this.showCertificateDeploymentRunning = false;
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.httpsCmdSuccess = true;
            }
            else {
                _this.commandOutputErrorMessage = commandoutput.commandErrorOutput;
            }
        }, function (error) {
            _this.showCertificateDeploymentRunning = false;
            _this.errorMessage = error;
            console.error('CertificateComponent ==> manageHttpsCertificate() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.certificateSubscriptionErrors = true;
        });
    };
    CertificateComponent.prototype.manageLdapCertificate = function () {
        var _this = this;
        this.ldapShowCmdResponseWindow = true;
        this.showCertificateDeploymentRunning = true;
        var file = this.filesToUploadLdap[0];
        this.certificateService.uploadLdapCertificate(file)
            .subscribe(function (commandoutput) {
            _this.showCertificateDeploymentRunning = false;
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.ldapCmdSuccess = true;
            }
            else {
                _this.commandOutputErrorMessage = commandoutput.commandErrorOutput;
            }
        }, function (error) {
            _this.showCertificateDeploymentRunning = false;
            _this.errorMessage = error;
            console.error('CertificateComponent ==> manageLdapCertificate() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.certificateSubscriptionErrors = true;
        });
    };
    CertificateComponent.prototype.tryNewLdapCertificate = function () {
        this.ldapShowCmdResponseWindow = false;
    };
    CertificateComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'certificate',
            templateUrl: '../views/certificate.component.html'
        }), 
        __metadata('design:paramtypes', [certificate_service_1.CertificateService, emi_service_1.EMIService])
    ], CertificateComponent);
    return CertificateComponent;
}());
exports.CertificateComponent = CertificateComponent;
