"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var Observable_1 = require('rxjs/Observable');
require('rxjs/add/operator/map');
require('rxjs/add/operator/catch');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var emi_service_1 = require('../../emi.service');
var CertificateService = (function () {
    function CertificateService(http, emiService, coreService) {
        this.http = http;
        this.emiService = emiService;
        this.coreService = coreService;
        this.checkHttpsCertificateUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/checkhttpscertificate';
        this.uploadHttpsCertificateUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/uploadhttpscertificate';
        this.checkLdapCertificateUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/checkldapcertificate';
        this.uploadLdapCertificateUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/uploadldapcertificate';
    }
    CertificateService.prototype.checkHttpsCertificate = function () {
        var headers = new http_1.Headers();
        headers.append('Content-Type', 'application/json');
        headers.append('Accept', 'application/json');
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var params = new http_1.URLSearchParams();
        params.set('filename', 'ecx-beta.crt');
        params.set('filepath', '/opt/ECX/virgo/configuration');
        var options = new http_1.RequestOptions({ headers: headers, search: params });
        return this.http.get(this.checkHttpsCertificateUrl, options)
            .map(this.extractDataFileDetails)
            .catch(this.handleError);
    };
    CertificateService.prototype.uploadHttpsCertificate = function (fileInput) {
        var file = fileInput;
        var formData = new FormData();
        formData.append('file', file, file.name);
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.uploadHttpsCertificateUrl, formData, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    CertificateService.prototype.uploadLdapCertificate = function (fileInput) {
        var file = fileInput;
        var formData = new FormData();
        formData.append('file', file, file.name);
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.uploadLdapCertificateUrl, formData, options)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    CertificateService.prototype.extractDataFileDetails = function (res) {
        var body = res.json();
        return body.filedetails || {};
    };
    CertificateService.prototype.extractDataCommandOutput = function (res) {
        var body = res.json();
        return body.commandoutput || {};
    };
    CertificateService.prototype.handleError = function (error) {
        // In a real world app, we might use a remote logging infrastructure
        var errMsg;
        if (error instanceof http_1.Response) {
            var body = error.json() || '';
            if (body.message !== undefined && body.message !== null) {
                if (body.message === "SessionId Timeout") {
                    errMsg = "SessionIdTimeout";
                }
                else {
                    var err = body.error || JSON.stringify(body);
                    errMsg = error.status + " - " + (error.statusText || '') + " " + err;
                }
            }
            else {
                var err = body.error || JSON.stringify(body);
                errMsg = error.status + " - " + (error.statusText || '') + " " + err;
            }
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        console.error('CertificateService ==> handleError() ==> ' + errMsg);
        return Observable_1.Observable.throw(errMsg);
    };
    CertificateService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, emi_service_1.EMIService, (typeof (_a = typeof core_service_1.CoreService !== 'undefined' && core_service_1.CoreService) === 'function' && _a) || Object])
    ], CertificateService);
    return CertificateService;
    var _a;
}());
exports.CertificateService = CertificateService;
