"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var Observable_1 = require('rxjs/Observable');
require('rxjs/add/operator/map');
require('rxjs/add/operator/catch');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var emi_service_1 = require('../../emi.service');
var EmiSettingsService = (function () {
    function EmiSettingsService(http, emiService, coreService) {
        this.http = http;
        this.emiService = emiService;
        this.coreService = coreService;
        this.urlCheck = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/checkurl';
        this.updateRepoUrl = this.emiService.getAdminconsoleEmiEndpointsUrl() + '/api/updaterepourl';
    }
    EmiSettingsService.prototype.checkYumRepoUrl = function (yumrepourl) {
        console.log('EmiSettingsService => checkYumRepoUrl() ==>');
        var formData = new FormData();
        formData.append('yumrepourl', yumrepourl);
        return this.http.post(this.urlCheck, formData)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    EmiSettingsService.prototype.updateYumRepoUrl = function (yumrepourl) {
        console.log('EmiSettingsService => updateYumRepoUrl() ==>');
        var formData = new FormData();
        formData.append('yumrepourl', yumrepourl);
        var headers = new http_1.Headers();
        headers.append(this.emiService.getSessionIdHeader(), this.coreService.getSessionId());
        var options = new http_1.RequestOptions({ headers: headers });
        return this.http.post(this.updateRepoUrl, formData)
            .map(this.extractDataCommandOutput)
            .catch(this.handleError);
    };
    EmiSettingsService.prototype.extractDataCommandOutput = function (res) {
        var body = res.json();
        return body.commandoutput || {};
    };
    EmiSettingsService.prototype.handleError = function (error) {
        // In a real world app, we might use a remote logging infrastructure
        var errMsg;
        if (error instanceof http_1.Response) {
            var body = error.json() || '';
            var err = body.error || JSON.stringify(body);
            errMsg = error.status + " - " + (error.statusText || '') + " " + err;
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        console.error(errMsg);
        return Observable_1.Observable.throw(errMsg);
    };
    EmiSettingsService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http, emi_service_1.EMIService, (typeof (_a = typeof core_service_1.CoreService !== 'undefined' && core_service_1.CoreService) === 'function' && _a) || Object])
    ], EmiSettingsService);
    return EmiSettingsService;
    var _a;
}());
exports.EmiSettingsService = EmiSettingsService;
