"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var emi_service_1 = require('../../emi.service');
var EntryComponent = (function () {
    function EntryComponent(router, emiService) {
        this.emiService = emiService;
        this.entrySubscriptionErrors = false;
        this.sessionTimeoutException = false;
    }
    EntryComponent.prototype.ngOnInit = function () {
        if (this.emiService.getSessionTimeOutStatus()) {
            this.sessionTimeoutException = true;
            this.entrySubscriptionErrors = true;
        }
        else {
            this.checkSelfUpdate();
        }
    };
    EntryComponent.prototype.checkSelfUpdate = function () {
        var _this = this;
        this.emiService.checkSelfupdateAvailable().
            subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                console.log('EntryComponent ==> checkSelfUpdate() ==>  Self update available');
                _this.emiService.setSelfupdateStatus(true);
            }
            else {
                console.log('EntryComponent ==> checkSelfUpdate() ==>  Self update NOT available');
                _this.emiService.setSelfupdateStatus(false);
            }
        }, function (error) {
            _this.errorMessage = error;
            console.error('EntryComponent ==> checkSelfUpdate ==> ' + _this.errorMessage);
        });
    };
    EntryComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'entry',
            templateUrl: '../views/entry.component.html'
        }), 
        __metadata('design:paramtypes', [router_1.Router, emi_service_1.EMIService])
    ], EntryComponent);
    return EntryComponent;
}());
exports.EntryComponent = EntryComponent;
