"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var license_service_1 = require('../services/license.service');
var emi_service_1 = require('../../emi.service');
var LicenseComponent = (function () {
    function LicenseComponent(licenseService, emiService) {
        this.licenseService = licenseService;
        this.emiService = emiService;
        this.licenseInfoAvailable = false;
        this.uploadButtonState = true;
        this.doesFileExist = false;
        this.cmdSuccess = false;
        this.showCmdResponseWindow = false;
        this.licenseSubscriptionErrors = false;
        this.sessionTimeoutException = false;
        this.showLicenseDeploymentRunning = false;
        this.licenseDataAvailable = false;
        this.licenseInfoHide = false;
        this.productName = this.getProductName();
    }
    LicenseComponent.prototype.ngOnInit = function () {
        if (this.emiService.getSessionTimeOutStatus()) {
            this.sessionTimeoutException = true;
            this.licenseSubscriptionErrors = true;
        }
        else {
            this.checkLicense();
        }
    };
    LicenseComponent.prototype.ngAfterViewInit = function () { };
    LicenseComponent.prototype.getProductName = function () {
        return this.emiService.getProductName();
    };
    LicenseComponent.prototype.getCompanyName = function () {
        return this.emiService.getCompanyName();
    };
    LicenseComponent.prototype.getPortalUrl = function () {
        return this.emiService.getPortalUrl();
    };
    LicenseComponent.prototype.fileChangeEvent = function (event) {
        this.filesToUpload = event.target.files;
        if (this.filesToUpload.length > 0) {
            this.uploadButtonState = false;
        }
    };
    LicenseComponent.prototype.checkLicense = function () {
        var _this = this;
        this.licenseService.checkLicense()
            .subscribe(function (filedetails) {
            _this.licenseInfoAvailable = true;
            _this.doesFileExist = filedetails.doesFileExist;
            _this.fileTime = filedetails.fileTime;
            _this.getLicenseData();
        }, function (error) {
            _this.licenseInfoAvailable = true;
            _this.errorMessage = error;
            console.error('LicenseComponent ==> checkLicense() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.licenseSubscriptionErrors = true;
        });
    };
    LicenseComponent.prototype.getLicenseData = function () {
        var lDataObj = this.licenseService.getLicenseInfo();
        if (lDataObj != null) {
            this.licenseDataAvailable = true;
            this.licenseActiveDate = new Date(lDataObj.activeDate).toDateString();
            this.licenseExpiryDate = new Date(lDataObj.expiryDate).toDateString();
            this.isLicenseCompliant = lDataObj.inCompliance;
            this.licenseType = lDataObj.licenseType;
            if (this.licenseType.trim() === "PERPETUAL") {
                this.licenseInfoHide = true;
            }
            this.licenseComplianceMessage = lDataObj.complianceMessage;
        }
    };
    LicenseComponent.prototype.manageLicense = function () {
        var _this = this;
        this.showCmdResponseWindow = true;
        this.showLicenseDeploymentRunning = true;
        var file = this.filesToUpload[0];
        this.licenseService.uploadLicense(file)
            .subscribe(function (commandoutput) {
            _this.showLicenseDeploymentRunning = false;
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.cmdSuccess = true;
            }
        }, function (error) {
            _this.showLicenseDeploymentRunning = false;
            _this.errorMessage = error;
            console.error('LicenseComponent ==> manageLicense() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.licenseSubscriptionErrors = true;
        });
    };
    LicenseComponent.prototype.updateLicense = function () {
        this.doesFileExist = false;
    };
    LicenseComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'license',
            templateUrl: '../views/license.component.html'
        }), 
        __metadata('design:paramtypes', [license_service_1.LicenseService, emi_service_1.EMIService])
    ], LicenseComponent);
    return LicenseComponent;
}());
exports.LicenseComponent = LicenseComponent;
