"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var Observable_1 = require('rxjs/Observable');
var core_2 = require('@ngx-translate/core');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var netconfig_model_1 = require('../model/netconfig.model');
var netconfig_service_1 = require('../services/netconfig.service');
var emi_service_1 = require('../../emi.service');
var NetconfigComponent = (function () {
    function NetconfigComponent(translate, netconfigService, emiService, coreService) {
        this.translate = translate;
        this.netconfigService = netconfigService;
        this.emiService = emiService;
        this.coreService = coreService;
        this.confirmRestartIcon = "sync icon";
        this.subs = [];
        this.showNetconfig = false;
        this.showRetrieving = false;
        this.showUpdating = false;
        this.showIp4AddChangeWarning = false;
        this.showStaticEx = false;
        this.sessionTimeoutException = false;
        this.netconfigSubscriptionErrors = false;
        this.productName = this.getProductName();
        this.showRetrieving = true;
        this.getNetworkConfig();
    }
    NetconfigComponent.prototype.confirmRestart = function () {
        this.uNetconfigModel = new netconfig_model_1.NetconfigModel(this.netconfigForm.get('hostname').value.trim(), this.netconfigModel.ninterface, this.netconfigForm.get('ip4address').value.trim(), this.netconfigForm.get('ip4prefix').value.trim(), this.netconfigForm.get('ip4gatewayaddress').value.trim(), this.netconfigForm.get('ip4dnsserver').value.trim(), this.netconfigForm.get('ip4domainsearch').value.trim(), this.bootProtocol, this.netconfigModel.connection);
        this.confirmRestartDialog.showConfirmationDialog();
    };
    NetconfigComponent.prototype.getProductName = function () {
        return this.emiService.getProductName();
    };
    NetconfigComponent.prototype.createNetconfigFormGroup = function () {
        return new forms_1.FormGroup({
            hostname: new forms_1.FormControl({ value: this.netconfigModel.hostname, disabled: false }, forms_1.Validators.required),
            ip4address: new forms_1.FormControl({ value: this.netconfigModel.ip4address, disabled: true }, forms_1.Validators.required),
            ip4prefix: new forms_1.FormControl({ value: this.netconfigModel.ip4prefix, disabled: true }, forms_1.Validators.required),
            ip4gatewayaddress: new forms_1.FormControl({ value: this.netconfigModel.ip4gateway, disabled: true }, forms_1.Validators.required),
            ip4dnsserver: new forms_1.FormControl({ value: this.netconfigModel.ip4dns, disabled: false }, forms_1.Validators.required),
            ip4domainsearch: new forms_1.FormControl({ value: this.netconfigModel.ip4domainsearch, disabled: false })
        });
    };
    NetconfigComponent.prototype.onTypeSelect = function (type) {
        this.bootProtocol = type;
        this.configureFormFields(true);
    };
    NetconfigComponent.prototype.configureFormFields = function (interactive) {
        if (this.bootProtocol === 'dhcp' || (!interactive && this.isDhcp)) {
            console.log('NetconfigComponent ==> onTypeSelect() ==> Selected type: ' + this.bootProtocol);
            this.showStaticEx = false;
            this.netconfigForm.controls['ip4address'].disable();
            this.netconfigForm.controls['ip4prefix'].disable();
            this.netconfigForm.controls['ip4gatewayaddress'].disable();
        }
        else if (this.bootProtocol === 'static' || (!interactive && this.isStatic)) {
            console.log('NetconfigComponent ==> onTypeSelect() ==> Selected type: ' + this.bootProtocol);
            this.netconfigForm.controls['hostname'].enable();
            this.netconfigForm.controls['ip4address'].enable();
            this.netconfigForm.controls['ip4prefix'].enable();
            this.netconfigForm.controls['ip4gatewayaddress'].enable();
            this.netconfigForm.controls['ip4dnsserver'].enable();
            this.netconfigForm.controls['ip4domainsearch'].enable();
            this.showStaticEx = true;
        }
    };
    NetconfigComponent.prototype.onReset = function () {
        var _this = this;
        this.showNetconfig = false;
        this.showRetrieving = true;
        this.getNetworkConfig().subscribe(function (model) { return _this.configureFormFields(); });
    };
    NetconfigComponent.prototype.onSubmitNetconfigForm = function () {
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getNavigationStatusKey(), false);
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getAdminconsoleNavigationStatusKey(), false);
        this.showNetconfig = false;
        this.showUpdating = true;
        if (this.isUpdateHostname(this.uNetconfigModel)) {
            this.updateHostname(this.uNetconfigModel);
        }
        else {
            if (this.isUpdateNetconfig(this.uNetconfigModel)) {
                this.updateNetconfig(this.uNetconfigModel);
            }
            else {
                if ((this.bootProtocol === "static" && this.isStatic === true) || (this.bootProtocol === "dhcp" && this.isDhcp === true)) {
                    this.showNetconfig = true;
                    this.showUpdating = false;
                }
                else {
                    this.updateNetconfig(this.uNetconfigModel);
                }
            }
        }
    };
    NetconfigComponent.prototype.isUpdateNetconfig = function (netconfigModel) {
        if (!(this.netconfigModel.ip4address === netconfigModel.ip4address)) {
            console.log("NetconfigComponent ==> isUpdateNetconfig() ==> ip4address need to be updated " + netconfigModel.ip4address);
            return true;
        }
        if (!(this.netconfigModel.ip4dns === netconfigModel.ip4dns)) {
            console.log("NetconfigComponent ==> isUpdateNetconfig() ==> ip4dns need to be updated " + netconfigModel.ip4dns);
            return true;
        }
        if (!(this.netconfigModel.ip4domainsearch === netconfigModel.ip4domainsearch)) {
            console.log("NetconfigComponent ==> isUpdateNetconfig() ==> ip4domainsearch need to be updated " + netconfigModel.ip4domainsearch);
            return true;
        }
        if (!(this.netconfigModel.ip4gateway === netconfigModel.ip4gateway)) {
            console.log("NetconfigComponent ==> isUpdateNetconfig() ==> ip4gateway need to be updated " + netconfigModel.ip4gateway);
            return true;
        }
        if (!(this.netconfigModel.ip4prefix === netconfigModel.ip4prefix)) {
            console.log("NetconfigComponent ==> isUpdateNetconfig() ==> ip4prefix need to be updated " + netconfigModel.ip4prefix);
            return true;
        }
        return false;
    };
    NetconfigComponent.prototype.isUpdateHostname = function (netconfigModel) {
        if (!(this.netconfigModel.hostname === netconfigModel.hostname)) {
            return true;
        }
        return false;
    };
    NetconfigComponent.prototype.updateNetconfig = function (netconfigModel) {
        var _this = this;
        this.newIP = netconfigModel.ip4address;
        console.log('NetconfigComponent ==> updateNetconfig() ==> Updating netconfig ...');
        this.netconfigService.updateNetconfig(netconfigModel)
            .catch(function (error) {
            _this.showUpdating = false;
            _this.errorMessage = netconfig_service_1.NetconfigService.mapToRootErrorMessage(error);
            _this.netconfigSubscriptionErrors = true;
            console.log(_this.errorMessage);
            return Observable_1.Observable.throw(error);
        })
            .subscribe(function (_) {
            _this.showUpdating = true;
            console.log('NetconfigComponent ==> updateNetconfig() ==> Starting restart interval ...');
            Observable_1.Observable.interval(360000).take(1).subscribe(function () {
                console.log('NetconfigComponent ==> updateNetconfig() ==> interval complete, restart adminconsole');
                _this.logout();
            });
        });
    };
    NetconfigComponent.prototype.updateHostname = function (netconfigModel) {
        var _this = this;
        console.log('NetconfigComponent ==> updateHostname() ==> ' + netconfigModel.hostname);
        this.netconfigService.updateHostname(netconfigModel.hostname)
            .subscribe(function (commandoutput) {
            var errorCode = commandoutput.errorCode;
            if (errorCode === "0") {
                console.log('NetconfigComponent ==> updateHostname() ==> Updated Hostname to ==> ' + netconfigModel.hostname);
                _this.updateNetconfig(netconfigModel);
            }
            else {
                _this.showUpdating = false;
                _this.errorMessage = _this.errorUpdatingHostname + ' ' + commandoutput.commandErrorOutput;
                _this.netconfigSubscriptionErrors = true;
                console.error('NetconfigComponent ==> updateHostname() ==> Update Hostname to ' + netconfigModel.hostname + ' Failed ' + commandoutput.commandErrorOutput);
            }
        }, function (error) {
            _this.showUpdating = false;
            _this.errorMessage = error;
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.emiService.setSessionTimedOut();
                _this.sessionTimeoutException = true;
            }
            console.error('NetconfigComponent ==> updateHostname() ==> ' + _this.errorMessage);
            _this.netconfigSubscriptionErrors = true;
        });
    };
    NetconfigComponent.prototype.getNetworkConfig = function () {
        var _this = this;
        console.log('NetconfigComponent ==> Getting network configuration ...');
        var observable = this.netconfigService.getNetconfigModel();
        observable.subscribe(function (netconfigmodel) {
            console.log('NetconfigComponent ==> getNetworkConfig() ==> Got network configuration ' + JSON.stringify(netconfigmodel));
            _this.netconfigModel = netconfigmodel;
            _this.netconfigForm = _this.createNetconfigFormGroup();
            if (_this.netconfigModel.bootProtocol === "none" || _this.netconfigModel.bootProtocol === "static") {
                _this.isStatic = true;
                _this.showStaticEx = true;
                _this.bootProtocol = "static";
            }
            else {
                _this.isDhcp = true;
                _this.showStaticEx = false;
                _this.bootProtocol = "dhcp";
            }
            _this.showRetrieving = false;
            _this.showNetconfig = true;
        }, function (error) {
            _this.errorMessage = error;
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.emiService.setSessionTimedOut();
                _this.sessionTimeoutException = true;
            }
            console.error('NetconfigComponent ==> getNetworkConfig() ==> ' + _this.errorMessage);
            _this.showRetrieving = false;
            _this.netconfigSubscriptionErrors = true;
        });
        return observable;
    };
    NetconfigComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.getNetworkConfig().subscribe(function (model) { return _this.configureFormFields(); });
        this.subs.push(this.translate.get([
            'NETCONFIG.IP4_ADDRESS_PLACEHOLDER',
            'NETCONFIG.IP4_GATEWAY_ADDRESS_PLACEHOLDER',
            'NETCONFIG.IP4_DNS_SERVERS_PLACEHOLDER',
            'NETCONFIG.IP4_DOMAIN_SERVERS_PLACEHOLDER',
            'NETCONFIG.HOSTNAME_PLACEHOLDER',
            'NETCONFIG.IP4_PREFIX_PLACEHOLDER',
            'NETCONFIG.ERROR_UPDATING_NETCONFIG',
            'NETCONFIG.ERROR_UPDATING_HOSTNAME',
            'NETCONFIG.ERROR_UPDATING_HOSTNAME',
            'NETCONFIG.MODAL_RESTART_HEADER',
            'NETCONFIG.MODAL_RESTART_MESSAGE',
            'NETCONFIG.YES',
            'NETCONFIG.NO'
        ])
            .subscribe(function (resource) {
            _this.ip4GatewayPlaceholder = resource['NETCONFIG.IP4_GATEWAY_ADDRESS_PLACEHOLDER'];
            _this.ip4AddressPlaceholder = resource['NETCONFIG.IP4_ADDRESS_PLACEHOLDER'];
            _this.ip4DnsPlaceholder = resource['NETCONFIG.IP4_DNS_SERVERS_PLACEHOLDER'];
            _this.ip4DomainSearchPlaceholder = resource['NETCONFIG.IP4_DOMAIN_SEARCH_PLACEHOLDER'];
            _this.ip4PrefixPlaceholder = resource['NETCONFIG.IP4_PREFIX_PLACEHOLDER'];
            _this.hostnamePlaceholder = resource['NETCONFIG.HOSTNAME_PLACEHOLDER'];
            _this.errorUpdatingNetconfig = resource['NETCONFIG.ERROR_UPDATING_NETCONFIG'];
            _this.errorUpdatingHostname = resource['NETCONFIG.ERROR_UPDATING_HOSTNAME'];
            _this.confirmRestartHeader = resource['NETCONFIG.MODAL_RESTART_HEADER'];
            _this.confirmRestartMessage = resource['NETCONFIG.MODAL_RESTART_MESSAGE'];
            _this.yesMessage = resource['NETCONFIG.YES'];
            _this.noMessage = resource['NETCONFIG.NO'];
        }, function (error) {
            console.error('NetconfigComponent: Error getting i18n values ' + error);
        }));
    };
    NetconfigComponent.prototype.logout = function () {
        console.log('NetconfigComponent ==> logout()');
        this.coreService.setSessionId(undefined, this.coreService.getCookie("adminconsole_portal_url") + "/api/endeavour/session");
        window.sessionId = undefined;
        this.deleteCreatedCookies();
        var newUrl = 'https://' + this.newIP + ':8090';
        console.log('NetconfigComponent ==> logout() ==> reloading application at ' + newUrl + ' !');
        window.location.href = newUrl;
    };
    /**
     * DELETE COOKIES
     * (Created cookies needs to be deleted here)
     * Called during admin console update before reloading the application
     */
    NetconfigComponent.prototype.deleteCreatedCookies = function () {
        this.coreService.deleteCookie("adminconsole_portal_url");
        this.coreService.deleteCookie("adminconsole_ms_url");
        this.coreService.deleteCookie("adminconsole_emims_url");
        this.coreService.deleteCookie("adminconsole_company_name");
        this.coreService.deleteCookie("adminconsole_product_name");
    };
    NetconfigComponent.prototype.goBackFromError = function () {
        this.showUpdating = false;
        this.showRetrieving = false;
        this.netconfigSubscriptionErrors = false;
        this.errorMessage = undefined;
        this.showNetconfig = true;
    };
    __decorate([
        core_1.ViewChild("confirmRestartDialog"), 
        __metadata('design:type', Object)
    ], NetconfigComponent.prototype, "confirmRestartDialog", void 0);
    NetconfigComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'netconfig',
            templateUrl: '../views/netconfig.component.html'
        }), 
        __metadata('design:paramtypes', [core_2.TranslateService, netconfig_service_1.NetconfigService, emi_service_1.EMIService, (typeof (_a = typeof core_service_1.CoreService !== 'undefined' && core_service_1.CoreService) === 'function' && _a) || Object])
    ], NetconfigComponent);
    return NetconfigComponent;
    var _a;
}());
exports.NetconfigComponent = NetconfigComponent;
